diff --git a/django/contrib/admin/templates/registration/password_reset_subject.html b/django/contrib/admin/templates/registration/password_reset_subject.html
new file mode 100644
index 0000000..45a354b
--- /dev/null
+++ b/django/contrib/admin/templates/registration/password_reset_subject.html
@@ -0,0 +1,3 @@
+{% load i18n %}{% autoescape off %}
+{% blocktrans %}Password reset on {{ site_name }}{% endblocktrans %}
+{% endautoescape %}
\ No newline at end of file
diff --git a/django/contrib/auth/fixtures/authtestdata.json b/django/contrib/auth/fixtures/authtestdata.json
index e0bdc24..c286743 100644
--- a/django/contrib/auth/fixtures/authtestdata.json
+++ b/django/contrib/auth/fixtures/authtestdata.json
@@ -31,7 +31,7 @@
             "groups": [], 
             "user_permissions": [], 
             "password": "sha1$6efc0$f93efe9fd7542f25a7be94871ea45aa95de57161", 
-            "email": "testclient@example.com", 
+            "email": "testclient2@example.com",
             "date_joined": "2006-12-17 07:03:31"
         }
     },
diff --git a/django/contrib/auth/forms.py b/django/contrib/auth/forms.py
index 7473279..d692086 100644
--- a/django/contrib/auth/forms.py
+++ b/django/contrib/auth/forms.py
@@ -117,8 +117,11 @@ class PasswordResetForm(forms.Form):
             raise forms.ValidationError(_("That e-mail address doesn't have an associated user account. Are you sure you've registered?"))
         return email
 
-    def save(self, domain_override=None, email_template_name='registration/password_reset_email.html',
-             use_https=False, token_generator=default_token_generator, from_email=None, request=None):
+    def save(self, domain_override=None,
+             subject_template_name='registration/password_reset_subject.html',
+             email_template_name='registration/password_reset_email.html',
+             use_https=False, token_generator=default_token_generator,
+             from_email=None, request=None):
         """
         Generates a one-use only link for resetting password and sends to the user
         """
@@ -130,7 +133,6 @@ class PasswordResetForm(forms.Form):
                 domain = current_site.domain
             else:
                 site_name = domain = domain_override
-            t = loader.get_template(email_template_name)
             c = {
                 'email': user.email,
                 'domain': domain,
@@ -140,8 +142,10 @@ class PasswordResetForm(forms.Form):
                 'token': token_generator.make_token(user),
                 'protocol': use_https and 'https' or 'http',
             }
-            send_mail(_("Password reset on %s") % site_name,
-                t.render(Context(c)), from_email, [user.email])
+            subject = loader.render_to_string(subject_template_name, c)
+            subject = ''.join(subject.splitlines())
+            email = loader.render_to_string(email_template_name, c)
+            send_mail(subject, email, from_email, [user.email])
 
 class SetPasswordForm(forms.Form):
     """
diff --git a/django/contrib/auth/tests/forms.py b/django/contrib/auth/tests/forms.py
index 5aa49e0..993c12f 100644
--- a/django/contrib/auth/tests/forms.py
+++ b/django/contrib/auth/tests/forms.py
@@ -242,6 +242,23 @@ class PasswordResetFormTest(TestCase):
         self.assertTrue(form.is_valid())
         self.assertEqual(form.cleaned_data['email'], u'jsmith3@example.com')
 
+    def test_custom_email_subject(self):
+        import os
+        from django.conf import settings
+        from django.core import mail
+
+        old_TEMPLATE_DIRS = settings.TEMPLATE_DIRS
+        settings.TEMPLATE_DIRS = (os.path.join(os.path.dirname(__file__), 'templates'),)
+        data = {'email': 'testclient@example.com'}
+        form = PasswordResetForm(data)
+        try:
+            self.assertTrue(form.is_valid())
+            form.save()
+
+            self.assertEqual(len(mail.outbox), 1)
+            self.assertEqual(mail.outbox[0].subject, u'Custom password reset on example.com')
+        finally:
+            settings.TEMPLATE_DIRS = old_TEMPLATE_DIRS
 
     def test_bug_5605(self):
         # bug #5605, preserve the case of the user name (before the @ in the
diff --git a/django/contrib/auth/tests/templates/registration/password_reset_subject.html b/django/contrib/auth/tests/templates/registration/password_reset_subject.html
new file mode 100644
index 0000000..f0d0eac
--- /dev/null
+++ b/django/contrib/auth/tests/templates/registration/password_reset_subject.html
@@ -0,0 +1,3 @@
+{% load i18n %}{% autoescape off %}
+{% blocktrans %}Custom password reset on {{ site_name }}{% endblocktrans %}
+{% endautoescape %}